# Ogre::FileStreamDataStream Class Reference

Common subclass of DataStream for handling data from std::basic_istream. More...

`#include <OgreDataStream.h>`

Inheritance diagram for Ogre::FileStreamDataStream:

[legend]

List of all members.

## Public Member Functions

| FileStreamDataStream (std::ifstream *s, bool freeOnClose=true)
| Construct stream from an STL stream.
| FileStreamDataStream (const String &name, std::ifstream *s, bool freeOnClose=true)
| Construct named stream from an STL stream.
| FileStreamDataStream (const String &name, std::ifstream *s, size_t size, bool freeOnClose=true)
| Construct named stream from an STL stream, and tell it the size.
| ~FileStreamDataStream ()
size_t | read (void *buf, size_t count)

Read the requisite number of bytes from the stream, stopping at the end of the file.

Parameters:

  | buf | Reference to a buffer pointer
  | count | Number of bytes to read

Returns:
  The number of bytes read

size_t | readLine (char *buf, size_t maxCount, const String &delim="\n")

Get a single line from the stream.

Remarks:
  The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Note:
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters:

  | buf | Reference to a buffer pointer
  | maxCount | The maximum length of data to be read, excluding the terminating character
  | delim | The delimiter to stop at

Returns:
  The number of bytes read, excluding the terminating character

void | skip (long count)
| Skip a defined number of bytes. This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.
void | seek (size_t pos)
| Repositions the read point to a specified byte.
size_t | tell (void) const
| Returns the current byte offset from beginning.
bool | eof (void) const
| Returns true if the stream has reached the end.
void | close (void)
| Close the stream; this makes further operations invalid.
const String & | getName (void)
| Returns the name of the stream, if it has one.
template<typename T>
DataStream & | operator>> (T &val)
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace.
virtual String | getAsString (void)
| Returns a String containing the entire stream.
virtual size_t | skipLine (const String &delim="\n")
| Skip a single line from the stream.
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)

## Protected Attributes

std::ifstream * | mpStream
| Reference to source stream.
bool | mFreeOnClose
String | mName
| The name (e.g. resource name) that can be used to identify the source fot his data (optional).
size_t | mSize
| Size of the data in the stream (may be 0 if size cannot be determined).

## Detailed Description

Common subclass of DataStream for handling data from std::basic_istream.

Definition at line 328 of file OgreDataStream.h.

## Constructor & Destructor Documentation

Ogre::FileStreamDataStream::FileStreamDataStream | ( | std::ifstream * | s,
|  | bool | freeOnClose = `true` |
| ) |  |  |

Construct stream from an STL stream.

Parameters:

  | s | Pointer to source stream
  | freeOnClose | Whether to delete the underlying stream on destruction of this class

Ogre::FileStreamDataStream::FileStreamDataStream | ( | const String & | name,
|  | std::ifstream * | s,
|  | bool | freeOnClose = `true` |
| ) |  |  |

Construct named stream from an STL stream.

Parameters:

  | name | The name to give this stream
  | s | Pointer to source stream
  | freeOnClose | Whether to delete the underlying stream on destruction of this class

Ogre::FileStreamDataStream::FileStreamDataStream | ( | const String & | name,
|  | std::ifstream * | s,
|  | size_t | size,
|  | bool | freeOnClose = `true` |
| ) |  |  |

Construct named stream from an STL stream, and tell it the size.

Remarks:
  This variant tells the class the size of the stream too, which means this class does not need to seek to the end of the stream to determine the size up-front. This can be beneficial if you have metadata about the contents of the stream already.

Parameters:

  | name | The name to give this stream
  | s | Pointer to source stream
  | size | Size of the stream contents in bytes
  | freeOnClose | Whether to delete the underlying stream on destruction of this class. If you specify 'true' for this you must ensure that the stream was allocated using OGRE_NEW_T with MEMCATEGRORY_GENERAL.

Ogre::FileStreamDataStream::~FileStreamDataStream | ( |  | ) |

## Member Function Documentation

size_t Ogre::FileStreamDataStream::read | ( | void * | buf,
|  | size_t | count |
| ) |  |  | `[virtual]`

Read the requisite number of bytes from the stream, stopping at the end of the file.

Parameters:

  | buf | Reference to a buffer pointer
  | count | Number of bytes to read

Returns:
  The number of bytes read

Implements Ogre::DataStream.

size_t Ogre::FileStreamDataStream::readLine | ( | char * | buf,
|  | size_t | maxCount,
|  | const String & | delim = `"\n"` |
| ) |  |  | `[virtual]`

Get a single line from the stream.

Remarks:
  The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Note:
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters:

  | buf | Reference to a buffer pointer
  | maxCount | The maximum length of data to be read, excluding the terminating character
  | delim | The delimiter to stop at

Returns:
  The number of bytes read, excluding the terminating character

Reimplemented from Ogre::DataStream.

void Ogre::FileStreamDataStream::skip | ( | long | count | ) | `[virtual]`

Skip a defined number of bytes.

This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.

Implements Ogre::DataStream.

void Ogre::FileStreamDataStream::seek | ( | size_t | pos | ) | `[virtual]`

Repositions the read point to a specified byte.

Implements Ogre::DataStream.

size_t Ogre::FileStreamDataStream::tell | ( | void |  | ) | const`[virtual]`

Returns the current byte offset from beginning.

Implements Ogre::DataStream.

bool Ogre::FileStreamDataStream::eof | ( | void |  | ) | const`[virtual]`

Returns true if the stream has reached the end.

Implements Ogre::DataStream.

void Ogre::FileStreamDataStream::close | ( | void |  | ) | `[virtual]`

Close the stream; this makes further operations invalid.

Implements Ogre::DataStream.

const String& Ogre::DataStream::getName | ( | void |  | ) | `[inherited]`

Returns the name of the stream, if it has one.

Definition at line 72 of file OgreDataStream.h.

template<typename T>

DataStream& Ogre::DataStream::operator>> | ( | T & | val | ) | `[inherited]`

virtual String Ogre::DataStream::getLine | ( | bool | trimAfter = `true` | ) | `[virtual, inherited]`

Returns a String containing the next line of data, optionally trimmed for whitespace.

Remarks:
  This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required.

Note:
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters:

  | trimAfter | If true, the line is trimmed for whitespace (as in String.trim(true,true))

virtual String Ogre::DataStream::getAsString | ( | void |  | ) | `[virtual, inherited]`

Returns a String containing the entire stream.

Remarks:
  This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream.

virtual size_t Ogre::DataStream::skipLine | ( | const String & | delim = `"\n"` | ) | `[virtual, inherited]`

Skip a single line from the stream.

Note:
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters:

  | delim | The delimiter(s) to stop at

Returns:
  The number of bytes skipped

Reimplemented in Ogre::MemoryDataStream.

size_t Ogre::DataStream::size | ( | void |  | ) | const`[inherited]`

Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.

Definition at line 149 of file OgreDataStream.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

std::ifstream* Ogre::FileStreamDataStream::mpStream `[protected]`

Reference to source stream.

Definition at line 332 of file OgreDataStream.h.

bool Ogre::FileStreamDataStream::mFreeOnClose `[protected]`

Definition at line 333 of file OgreDataStream.h.

String Ogre::DataStream::mName `[protected, inherited]`

The name (e.g. resource name) that can be used to identify the source fot his data (optional).

Definition at line 62 of file OgreDataStream.h.

size_t Ogre::DataStream::mSize `[protected, inherited]`

Size of the data in the stream (may be 0 if size cannot be determined).

Definition at line 64 of file OgreDataStream.h.

The documentation for this class was generated from the following file:

- OgreDataStream.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:33:05 2009